    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.io.PushbackInputStream

    java.lang.Object
       |
       +----java.io.InputStream
               |
               +----java.io.FilterInputStream
                       |
                       +----java.io.PushbackInputStream

public class PushbackInputStream
extends FilterInputStream

This class is an input stream filter that provides a buffer into which data can be "unread." An application may unread data at any time by pushing it back into the buffer, as long as the buffer has sufficient room. Subsequent reads will read all of the pushed-back data in the buffer before reading from the underlying input stream.

This functionality is useful when a fragment of code should read an indefinite number of data bytes that are delimited by particular byte values. After reading the terminating byte the code fragment can push it back, so that the next read operation on the input stream will re-read that byte.

##

buf
  The pushback buffer.
pos
  The position within the pushback buffer from which the next byte will be read.

##

PushbackInputStream(InputStream)
  Creates a new pushback input stream with a one-byte pushback buffer.
PushbackInputStream(InputStream, int)
  Creates a new pushback input stream with a pushback buffer of the specified size.

##

available()
  Returns the number of bytes that can be read from this input stream without blocking.
markSupported()
  Tests if this input stream supports the `mark` and `reset` methods, which it does not.
read()
  Reads the next byte of data from this input stream.
read(byte[], int, int)
  Reads up to `len` bytes of data from this input stream into an array of bytes.
unread(byte[])
  Pushes back an array of bytes by copying it to the front of the pushback buffer.
unread(byte[], int, int)
  Pushes back a portion of an array of bytes by copying it to the front of the pushback buffer.
unread(int)
  Pushes back a byte by copying it to the front of the pushback buffer.

##

buf

     protected byte buf[]

  The pushback buffer.

pos

     protected int pos

  The position within the pushback buffer from which the next byte will be read. When the buffer is empty, `pos` is equal to `buf.length`; when the buffer is full, `pos` is equal to zero.

##

PushbackInputStream

     public PushbackInputStream(InputStream in,
                                int size)

  Creates a new pushback input stream with a pushback buffer of the specified size.

  Parameters:
    in - the input stream from which bytes will be read.
    size - the size of the pushback buffer.

PushbackInputStream

     public PushbackInputStream(InputStream in)

  Creates a new pushback input stream with a one-byte pushback buffer.

  Parameters:
    in - the input stream from which bytes will be read.

##

read

     public int read() throws IOException

  Reads the next byte of data from this input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  This method returns the most recently pushed-back byte, if there is one, and otherwise calls the `read` method of its underlying input stream and returns whatever value that method returns.

  Returns:
    the next byte of data, or `-1` if the end of the stream has been reached.
  Throws: IOException
    if an I/O error occurs.
  Overrides:
    read in class FilterInputStream
  See Also:
    read

read

     public int read(byte b[],
                     int off,
                     int len) throws IOException

  Reads up to `len` bytes of data from this input stream into an array of bytes. This method first reads any pushed-back bytes; after that, if fewer than than `len` bytes have been read then it reads from the underlying input stream. This method blocks until at least 1 byte of input is available.

  Parameters:
    b - the buffer into which the data is read.
    off - the start offset of the data.
    len - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws: IOException
    if an I/O error occurs.
  Overrides:
    read in class FilterInputStream

unread

     public void unread(int b) throws IOException

  Pushes back a byte by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `(byte)b`.

  Parameters:
    b - the `int` value whose low-order byte is to be pushed back.
  Throws: IOException
    If there is not enough room in the pushback buffer for the byte.

unread

     public void unread(byte b[],
                        int off,
                        int len) throws IOException

  Pushes back a portion of an array of bytes by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `b[off]`, the byte after that will have the value `b[off+1]`, and so forth.

  Parameters:
    b - the byte array to push back.
    off - the start offset of the data.
    len - the number of bytes to push back.
  Throws: IOException
    If there is not enough room in the pushback buffer for the specified number of bytes.

unread

     public void unread(byte b[]) throws IOException

  Pushes back an array of bytes by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `b[0]`, the byte after that will have the value `b[1]`, and so forth.

  Parameters:
    b - the byte array to push back
  Throws: IOException
    If there is not enough room in the pushback buffer for the specified number of bytes.

available

     public int available() throws IOException

  Returns the number of bytes that can be read from this input stream without blocking. This method calls the `available` method of the underlying input stream; it returns that value plus the number of bytes that have been pushed back.

  Returns:
    the number of bytes that can be read from the input stream without blocking.
  Throws: IOException
    if an I/O error occurs.
  Overrides:
    available in class FilterInputStream
  See Also:
    in

markSupported

     public boolean markSupported()

  Tests if this input stream supports the `mark` and `reset` methods, which it does not.

  Returns:
    `false`, since this class does not support the `mark` and `reset` methods.
  Overrides:
    markSupported in class FilterInputStream
  See Also:
    mark, reset

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.